<%--
 * Component: archive
 *
 * Description:
 *   WEB interface listing archive content.
 *
 * Parameters:
 *
 *   General table parameters: filters, fields, pagesize, ...
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@page import="imagemed.types.flag.IMTypeur"%>
<%@
	page import="imagemed.tables.*,imagemed.jsputil.*,imagemed.imtables.*,java.util.*,imagemed.imsession.*,imagemed.util.*,imagemed.http.*,imagemed.dotcom.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	IMSession is = new IMSession(request, response, out);
	if (!is.regOK()) {
		return;
	}
	
	if (!TabToolbox.hasLicense(is, TabBean.LICENSE_ARCHIVE)) { // no archive license
		if (!TabToolbox.hasLicense(is, TabBean.LICENSE_QR)) { // no QR license
			response.sendRedirect("/archive/dicomdir.jsp?cMode=Client");
		}
		else {
			response.sendRedirect("/qr/index.jsp");
		}
		return;
	}

	if( !is.hasRight( IMTypeur.ARCHIVE_RIGHT ) ) { // no archive right, redirect to Media Import or Media Creation
		if( is.hasRight( IMTypeur.IMPORT_CD ) ) {
			response.sendRedirect("/archive/dicomdir.jsp?cMode=Client" );
		}
		else {
			response.sendRedirect("/cd/burncd.jsp?cStart=check" );
		}
	}

	IMRequest parReq = is.imRequest;
	String context = parReq.m_context;
	if (context == null || context.length() == 0) {
		context = parReq.backupContext();

		response.sendRedirect("/cases/dcfilterb.jsp?cContext=" + context + "&cIndexPage=/archive/index.jsp&cIndexTab=Archive");
		return;
	}

	parReq.passAsFile(context);

	boolean hasAdminRight = (-1 != is.regRights.indexOf('A'));

	String thisPage = "/archive/index.jsp";

//	String parentHost = null;
//	try {
//		parentHost = DotcomToolbox.getParentHost();
//	}
//	catch (Throwable th) {}
	
//	String passParentHost = parentHost == null ? "" : "&cHost=" + Helper.URLEncode(parentHost);

	String fields[] = TableParams.getDefaultFields("/archive/index.jsp", is);
	String sort[] = TableParams.getDefaultSorts("/archive/index.jsp");

	TableDescriptor tdesc = new TableDescriptor(thisPage);
	TableProperties tprop = new TableProperties();

	TableParams tparams = new TableParams(is.imRequest);
	tparams.setDefaultFields(fields);
	tparams.setDefaultSort(sort);
	tparams.setDefaultPage(1);
	tparams.setDefaultPageSize(20);

	ArchivesFieldManager fm = new ArchivesFieldManager( ArchivesFieldManager.MODE.EP_ARCHIVES, ArchivesFieldManager.ISSUER.LOCAL ); 
	
	tdesc.setTableParams( tparams );
	tdesc.setTableProperties( tprop );
	tdesc.setFieldManager( fm );
	tdesc.setSortDepth( 3 );

	
	boolean needObsLink = hasAdminRight && fm.hasNonReadonlyEPArchive();
	
	Action act[] = new Action[ needObsLink ? 3 : 2 ];
	act[0] = new ArchiveCheckbox( tprop, false );
	act[1] = new ArchiveAction( tdesc, "SYUI", "/archive/get.jsp?cDevStudy=$$RSRC$$+$$SYUI$$" );
	if ( needObsLink ) {
		act[ 2 ] = new ArchiveObsoleteAction( tdesc, "SYUI",
				"/archive/obs.jsp?cDevStudy=$$RSRC$$+$$SYUI$$", "<script language=\"JavaScript\">getImage(\'delete\', 17, 20, \' alt=\"Obsolete study\"\');</script>",
				"set study obsolete" );
	}

	Action[] batchActions = new Action[ needObsLink ? 2 : 1 ];
	batchActions[ 0 ] = new StaticLinkAction(
			"<a href=\"javascript:doSubmit();\"><script language=\"JavaScript\">getImage(\'get\', 16, 20, \' alt=\"Retrieve selected studies\"\');</script></a>",
			tprop, "" );
	if ( needObsLink ) {
		batchActions[ 1 ] = new StaticLinkAction(
				"<a href=\"javascript:doSubmit('obs.jsp');\"><script language=\"JavaScript\">getImage(\'delete\', 17, 20, \' alt=\"Obsolete selected studies\"\');</script></a>",
				tprop, "" );
	}
	Column col = new Column(new BatchHeader(batchActions), new ActionCell("SYUI", act), "SYUI");

	tdesc.addExtraColumn("_FIRST", col);

	Properties TDsettingsPage = new Properties();
	TDsettingsPage.setProperty("align", "right");
	TDsettingsPage.setProperty("width", "100%");

	TopCell topCell[] = new TopCell[4];
	topCell[0] = new TitleTopCell(tprop, LocalizedMessage.getSimpleMessage( "tabArchive"  ) );
	topCell[1] = new FiltersTopCell( tdesc, null );
	topCell[2] = new SortsTopCell( tdesc, null );
	topCell[3] = new PageTopCell(tprop, tparams, TDsettingsPage);

	tdesc.setTopCells(topCell);
	ArchivesResult result = new ArchivesResult(tdesc, DotcomConfig.selfId());

	String resultID = result.getResultID();

	if (resultID != null && !resultID.equals(parReq.getVal("cResultID"))) {
		parReq.setProperty("cResultID", resultID);
		parReq.passAsFile(parReq.m_context);
	}

	tdesc.setResult(result);

	tdesc.formParams = " action=\"get.jsp\" method=\"POST\"";

	Table table = new Table(tdesc);%>
<%@page import="imagemed.http.tabs.TabBean"%><HTML><HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "tabArchive" ) %></TITLE>
	<SCRIPT Language="JavaScript">
		var pageContext="<%=context%>";
	</script>
<%
	TabToolbox.writeIMpopup(out);
	table.printScript(tparams, is, new String[]{ArchiveCheckbox.CHECKBOXNAME});
%>
	<script language="JavaScript">
<%--
		function Select_( pTF ) {
			var i;
			for ( i = 0; i < self.document.Batch.length; i++ ) {
				if ( self.document.Batch.elements[i].name == 'cStudy' ) {
					self.document.Batch.elements[i].checked = pTF;
				}
			}
		}
--%>
		function forceRetrieve(device, study) {
			text = LocalizedMessage.getSimpleMessage( "ARCHIVE_INDEX_STUDY_RETRIEVED" );
			if (confirm(text)) {
				document.location="/archive/get.jsp?cDevStudy="+device+"+"+study;
			}
		}

		function doSubmit(page) {
			if (page) {
				self.document.Batch.action=page;
			}
			self.document.Batch.submit();
		}
	</script>
</HEAD>
<BODY>
<%
	TabToolbox.makeTabs(is, is.tabbean, "archive/index.jsp", "White");
	table.printTableTop(is);
	table.print(is);
%></CENTER>
<%--
<pre>
<%= result.getDebug() %>
</pre>
--%>
</BODY></HTML>
